'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  ', '\n  ', '\n'], ['\n  ', '\n  ', '\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _responsiveContext = require('./lib/responsive-context');

var _responsiveContext2 = _interopRequireDefault(_responsiveContext);

var _responsiveSetCss = require('./lib/responsive-set-css');

var _responsiveSetCss2 = _interopRequireDefault(_responsiveSetCss);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ResponsiveComponent = function (_React$Component) {
  _inherits(ResponsiveComponent, _React$Component);

  function ResponsiveComponent() {
    _classCallCheck(this, ResponsiveComponent);

    return _possibleConstructorReturn(this, (ResponsiveComponent.__proto__ || Object.getPrototypeOf(ResponsiveComponent)).apply(this, arguments));
  }

  _createClass(ResponsiveComponent, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          commonCss = _props.commonCss,
          responsiveSet = _props.responsiveSet,
          _props$tagName = _props.tagName,
          tagName = _props$tagName === undefined ? 'div' : _props$tagName;

      var _ref = this.context || {},
          options = _ref.options;

      var StyledWrapper = styled(tagName, commonCss, responsiveSet, options);

      return _react2.default.createElement(
          StyledWrapper,
          null,
          children
      );
    }
  }]);

  return ResponsiveComponent;
}(_react2.default.Component);

ResponsiveComponent.contextType = _responsiveContext2.default;


ResponsiveComponent.propTypes = {
  commonCss: _propTypes2.default.string,
  responsiveSet: _propTypes2.default.array,
  tagName: _propTypes2.default.string
};

var styled = function styled(tagName) {
  var commonCss = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var responsiveSet = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var options = arguments[3];
  return (0, _styledComponents2.default)(tagName)(_templateObject, commonCss, (0, _responsiveSetCss2.default)(responsiveSet, options));
};

exports.default = ResponsiveComponent;
