'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _responsiveContext = require('./lib/responsive-context');

var _responsiveContext2 = _interopRequireDefault(_responsiveContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ResponsiveWrapper = function ResponsiveWrapper(_ref) {
  var children = _ref.children,
      options = _ref.options;

  var responsiveConfig = {
    value: {
      options: options
    }
  };

  return _react2.default.createElement(
      _responsiveContext2.default.Provider,
      responsiveConfig,
      children
  );
};

ResponsiveWrapper.propTypes = {
  options: _propTypes2.default.shape({
    mediaSizes: _propTypes2.default.object,
    mediaQueries: _propTypes2.default.object,
    printCurrent: _propTypes2.default.bool
  })
};

exports.default = ResponsiveWrapper;
